/*
 * $Source: /home/gjvc/rnd/apache/modules/mod_log_access/mod_log_access-CURRENT/RCS/log_timeutils.h,v $
 * $Id: log_timeutils.h,v 1.20 2006/12/27 12:22:57 gjvc Exp $
 */

#ifndef LOG_TIMEUTILS_H
#define LOG_TIMEUTILS_H


/* ---- begin constants  ---- */

/* seconds per minute, hour, day and week */
#define SECONDS_PER_MINUTE      ( 60 )
#define SECONDS_PER_HOUR        ( 60 * SECONDS_PER_MINUTE )
#define SECONDS_PER_DAY         ( 24 * SECONDS_PER_HOUR )
#define SECONDS_PER_WEEK        (  7 * SECONDS_PER_DAY )

/* allowances for daylight saving time and leap second (used for calculating the start of the next interval) */
#define LEAP_SECOND_ALLOWANCE     ( 2 )
#define DST_ALLOWANCE           ( ( 3 * SECONDS_PER_HOUR ) + LEAP_SECOND_ALLOWANCE )

/* ---- end constants  ---- */


/* ---- begin types ---- */

typedef enum {

    INTERVAL_SECOND,
    INTERVAL_MINUTE,
    INTERVAL_HOUR,
    INTERVAL_DAY,
    INTERVAL_WEEK,
    INTERVAL_MONTH,
    INTERVAL_YEAR,
    INTERVAL_INFINITY

} interval_t;

/* ---- end types ---- */


/* ---- begin function prototypes ---- */

apr_status_t log_timeutils_explode_localtime(apr_time_exp_t *tm, apr_time_t t);

interval_t  log_timeutils_determine_interval(const char *);

apr_time_t  log_timeutils_start_of_current_interval(apr_time_t, interval_t);
apr_time_t  log_timeutils_start_of_next_interval(apr_time_t, interval_t);
                
char        *log_timeutils_timestamp_as_text(apr_time_t);
const char  *log_timeutils_interval_as_text(interval_t);

const char  *log_timeutils_get_version(void);

/* ---- end function prototypes ---- */


#endif
